package com.fp.persistence.pgeneral.acco;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.sql.Date;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fp.dto.hb.HibernateBean;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEACCOUNTLOCALHOLD */
@Entity(name = "TgeneAccountLocalHold")
@Table(name = "TGENEACCOUNTLOCALHOLD")
public class TgeneAccountLocalHold extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable {
    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TgeneAccountLocalHold
     */
    @EmbeddedId
    private TgeneAccountLocalHoldKey pk;

    @Column(name = "ACCOUNTMODULE", nullable = true)
    /**
     * Codigo de modulo al que pertenece la cuenta depositada.
     */
    private String accountmodule;

    @Column(name = "OFFICECODE", nullable = true)
    /**
     * Codigo de oficina
     */
    private Integer officecode;

    @Column(name = "BRANCHCODE", nullable = true)
    /**
     * Codigo de sucursal
     */
    private Integer branchcode;

    @Column(name = "ACCOUNTINGDATE", nullable = true)
    /**
     * Fecha contable con la cual se crea el registro de cheques locales
     */
    private Date accountingdate;

    @Column(name = "OWNACCOUNT", nullable = true)
    /**
     * Numero de cuenta duenia del cheque
     */
    private String ownaccount;

    @Column(name = "CHECKNUMBER", nullable = true)
    /**
     * Numero de cheque
     */
    private Integer checknumber;

    @Column(name = "CHECKVALUE", nullable = true)
    /**
     * Valor del cheque,  si no existe numero de cheque y el deposito se recibe cheque es el valor total de cheques.
     */
    private BigDecimal checkvalue;

    @Column(name = "TRANSITROUTE", nullable = true)
    /**
     * Codigo de ruta transito asociada al cheque
     */
    private String transitroute;

    @Column(name = "DATETORELEASE", nullable = true)
    /**
     * Fecha en la que se tiene que confirma los fondos en la cuenta depositada.
     */
    private Date datetorelease;

    @Column(name = "RELEASED", nullable = true)
    /**
     * Y indica que el cheque esta confirmado.
     */
    private String released;

    @Column(name = "RELEASEDDATE", nullable = true)
    /**
     * Fecha de confirmacion de fondos en la cuenta depositada
     */
    private Date releaseddate;

    @Column(name = "RETURNED", nullable = true)
    /**
     * Indica, si el cheque esta devuelto.
     */
    private String returned;

    @Column(name = "RETURNEDDATE", nullable = true)
    /**
     * Fecha en la que se devolvio el cheque.
     */
    private Date returneddate;

    @Column(name = "JOURNALID", nullable = true)
    /**
     * Numero de mensaje con el que se registra los datos del cheque
     */
    private String journalid;

    /** Contructor por defecto */
    public TgeneAccountLocalHold() {
    }

    /**
     * Contructor de TgeneAccountLocalHold
     * 
     * @param pPk Clave Primaria del entity
     */
    public TgeneAccountLocalHold(TgeneAccountLocalHoldKey pPk) {
        this();
        this.pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TgeneAccountLocalHold
     */
    public static TgeneAccountLocalHold find(EntityManager pEntityManager, TgeneAccountLocalHoldKey pKey) throws Exception {
        TgeneAccountLocalHold obj = pEntityManager.find(TgeneAccountLocalHold.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TgeneAccountLocalHold
     * 
     * @return El objeto que referencia a la Clave primaria de TgeneAccountLocalHold
     */
    public TgeneAccountLocalHoldKey getPk() {
        return this.pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TgeneAccountLocalHold
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TgeneAccountLocalHold
     */
    public void setPk(TgeneAccountLocalHoldKey pPk) {
        this.pk = pPk;
    }

    /**
     * Obtiene el valor de accountmodule
     * 
     * @return valor de accountmodule
     */
    public String getAccountmodule() {
        return this.accountmodule;
    }

    /**
     * Fija el valor de accountmodule
     * 
     * @param pAccountmodule nuevo Valor de accountmodule
     */
    public void setAccountmodule(String pAccountmodule) {
        this.accountmodule = pAccountmodule;
    }

    /**
     * Obtiene el valor de officecode
     * 
     * @return valor de officecode
     */
    public Integer getOfficecode() {
        return this.officecode;
    }

    /**
     * Fija el valor de officecode
     * 
     * @param pOfficecode nuevo Valor de officecode
     */
    public void setOfficecode(Integer pOfficecode) {
        this.officecode = pOfficecode;
    }

    /**
     * Obtiene el valor de branchcode
     * 
     * @return valor de branchcode
     */
    public Integer getBranchcode() {
        return this.branchcode;
    }

    /**
     * Fija el valor de branchcode
     * 
     * @param pBranchcode nuevo Valor de branchcode
     */
    public void setBranchcode(Integer pBranchcode) {
        this.branchcode = pBranchcode;
    }

    /**
     * Obtiene el valor de accountingdate
     * 
     * @return valor de accountingdate
     */
    public Date getAccountingdate() {
        return this.accountingdate;
    }

    /**
     * Fija el valor de accountingdate
     * 
     * @param pAccountingdate nuevo Valor de accountingdate
     */
    public void setAccountingdate(Date pAccountingdate) {
        this.accountingdate = pAccountingdate;
    }

    /**
     * Obtiene el valor de ownaccount
     * 
     * @return valor de ownaccount
     */
    public String getOwnaccount() {
        return this.ownaccount;
    }

    /**
     * Fija el valor de ownaccount
     * 
     * @param pOwnaccount nuevo Valor de ownaccount
     */
    public void setOwnaccount(String pOwnaccount) {
        this.ownaccount = pOwnaccount;
    }

    /**
     * Obtiene el valor de checknumber
     * 
     * @return valor de checknumber
     */
    public Integer getChecknumber() {
        return this.checknumber;
    }

    /**
     * Fija el valor de checknumber
     * 
     * @param pChecknumber nuevo Valor de checknumber
     */
    public void setChecknumber(Integer pChecknumber) {
        this.checknumber = pChecknumber;
    }

    /**
     * Obtiene el valor de checkvalue
     * 
     * @return valor de checkvalue
     */
    public BigDecimal getCheckvalue() {
        return this.checkvalue;
    }

    /**
     * Fija el valor de checkvalue
     * 
     * @param pCheckvalue nuevo Valor de checkvalue
     */
    public void setCheckvalue(BigDecimal pCheckvalue) {
        this.checkvalue = pCheckvalue;
    }

    /**
     * Obtiene el valor de transitroute
     * 
     * @return valor de transitroute
     */
    public String getTransitroute() {
        return this.transitroute;
    }

    /**
     * Fija el valor de transitroute
     * 
     * @param pTransitroute nuevo Valor de transitroute
     */
    public void setTransitroute(String pTransitroute) {
        this.transitroute = pTransitroute;
    }

    /**
     * Obtiene el valor de datetorelease
     * 
     * @return valor de datetorelease
     */
    public Date getDatetorelease() {
        return this.datetorelease;
    }

    /**
     * Fija el valor de datetorelease
     * 
     * @param pDatetorelease nuevo Valor de datetorelease
     */
    public void setDatetorelease(Date pDatetorelease) {
        this.datetorelease = pDatetorelease;
    }

    /**
     * Obtiene el valor de released
     * 
     * @return valor de released
     */
    public String getReleased() {
        return this.released;
    }

    /**
     * Fija el valor de released
     * 
     * @param pReleased nuevo Valor de released
     */
    public void setReleased(String pReleased) {
        this.released = pReleased;
    }

    /**
     * Obtiene el valor de releaseddate
     * 
     * @return valor de releaseddate
     */
    public Date getReleaseddate() {
        return this.releaseddate;
    }

    /**
     * Fija el valor de releaseddate
     * 
     * @param pReleaseddate nuevo Valor de releaseddate
     */
    public void setReleaseddate(Date pReleaseddate) {
        this.releaseddate = pReleaseddate;
    }

    /**
     * Obtiene el valor de returned
     * 
     * @return valor de returned
     */
    public String getReturned() {
        return this.returned;
    }

    /**
     * Fija el valor de returned
     * 
     * @param pReturned nuevo Valor de returned
     */
    public void setReturned(String pReturned) {
        this.returned = pReturned;
    }

    /**
     * Obtiene el valor de returneddate
     * 
     * @return valor de returneddate
     */
    public Date getReturneddate() {
        return this.returneddate;
    }

    /**
     * Fija el valor de returneddate
     * 
     * @param pReturneddate nuevo Valor de returneddate
     */
    public void setReturneddate(Date pReturneddate) {
        this.returneddate = pReturneddate;
    }

    /**
     * Obtiene el valor de journalid
     * 
     * @return valor de journalid
     */
    public String getJournalid() {
        return this.journalid;
    }

    /**
     * Fija el valor de journalid
     * 
     * @param pJournalid nuevo Valor de journalid
     */
    public void setJournalid(String pJournalid) {
        this.journalid = pJournalid;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TgeneAccountLocalHold)) {
            return false;
        }
        TgeneAccountLocalHold that = (TgeneAccountLocalHold) rhs;
        if ((this.getPk() == null) || (that.getPk() == null)) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementación del metodo hashCode de la la entidad TgeneAccountLocalHold
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /** Implementación toString */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if ((name.compareTo("hashValue") == 0) || (name.compareTo("serialVersionUID") == 0)) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /** Implementación de la creación de un bean en blanco TgeneAccountLocalHold */
    @Override
    public Object createInstance() {
        TgeneAccountLocalHold instance = new TgeneAccountLocalHold();
        instance.setPk(new TgeneAccountLocalHoldKey());
        return instance;
    }

    /**
     * Clona la entidad TgeneAccountLocalHold
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TgeneAccountLocalHold p = (TgeneAccountLocalHold) this.clone();
        p.setPk((TgeneAccountLocalHoldKey) this.pk.cloneMe());
        return p;
    }

    // METODOS MANUALES
    /** Sentencia que entrega los datos de un registro de TgeneAccountLocalHold, dado un numero de mensaje. */
    private static final String JPQL_LOCAL_HOLD = "from TgeneAccountLocalHold t " + " where t.journalid = :journalid ";

    /**
     * Metodo que entrega datos de TgeneAccountLocalHold dado un numero de mensaje.
     * 
     * @param pEntityManager Session de la base de datos.
     * @param pJournalid Numero de mensaje a obtener TgeneAccountLocalHold.
     * @return TgeneAccountLocalHold
     * @throws Exception
     */
    public static TgeneAccountLocalHold findByJournalId(EntityManager pEntityManager, String pJournalid) throws Exception {
        Query qry = pEntityManager.createQuery(TgeneAccountLocalHold.JPQL_LOCAL_HOLD);
        qry.setParameter("journalid", pJournalid);
        try {
            return (TgeneAccountLocalHold) qry.getSingleResult();
        } catch (NoResultException e) {
            return null;
        }
    }

}
